BOOT3  ;	BOOT3/ASM
 	ORG	0E140H
 SERIAL	EQU	42D8H
 BADSER	EQU	4343H
 	LD	SP,0E400H
 	CALL	CHECK
 	LD	A,(42EFH)	;boot speed
 	AND	3
 	LD	(0E140H),A
 	LD	HL,37ECH
 	LD	A,1
 	LD	(37E1H),A
 	LD	A,(0E140H)
 	OR	58H
 	LD	(HL),A
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 WAIT	BIT	0,(HL)
 	JR	NZ,WAIT
 	LD	A,15
 	EX	AF,AF'
 	LD	BC,4000H
 	LD	DE,0200H
 	LD	A,D
 	LD	(37EDH),A
 LOOP	CALL	READ
 	JP	NZ,ERROR
 	LD	HL,3C00H+40H
 VIDSAV	EQU	$-2
 	LD	(HL),'.'
 	INC	HL
 	LD	(VIDSAV),HL
 	EX	AF,AF'
 	DEC	A
 	JR	Z,ENTRY
 	EX	AF,AF'
 	INC	D
 	JR	LOOP
 ENTRY	RST	8
 XR1	LD	A,1
 	LD	(37E1H),A
 	LD	(37EEH),DE
 	LD	HL,37ECH
 	LD	A,(0E140H)
 	OR	18H
 	LD	(HL),A
 	CALL	DSKSLO
 HOLD	BIT	0,(HL)
 	JR	NZ,HOLD
 	LD	(HL),80H
 	PUSH	DE
 	LD	DE,37EFH
 	CALL	DSKSLO
 	JR	R1
 R0	RRCA
 	JR	NC,R2
 R1	LD	A,(HL)
 	BIT	1,A
 	JR	Z,R0
 	LD	A,(DE)
 	LD	(BC),A
 	INC	BC
 	JR	R1
 R2	LD	A,(HL)
 	AND	9CH
 	POP	DE
 	LD	(HL),0D0H
 	RET
 ERROR	CALL	CLS
 	LD	HL,MSG
 	LD	DE,3C00H
 	LD	BC,16
 	LDIR
 	LD	HL,3840H
 STOP	BIT	1,(HL)
 	JR	Z,STOP
 	LD	A,1
 	LD	(37E1H),A
 	LD	BC,0
 	CALL	60H
 	HALT
 CLS	LD	HL,3C00H
 	LD	DE,3C01H
 	LD	BC,1023
 	LD	(HL),80H
 	LDIR
 	RET
 DSKSLO	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	RET
 CHECK	LD	HL,SERIAL
 	LD	DE,SERNO
 	LD	B,7
 TEST	LD	A,(DE)
 	XOR	44H
 	CP	(HL)
 	JP	NZ,BADSER
 	INC	DE
 	INC	HL
 	DJNZ	TEST
 	RET
 	DB	1,2,3,4
 SERNO	DB	'0000000'
 MSG	DB	' - DISK ERROR - '
 READ	PUSH	BC
 	CALL	XR1
 	POP	HL
 	RET	Z
 	LD	B,H
 	LD	C,L
 	PUSH	BC
 	CALL	XR1
 	POP	HL
 	RET	Z
 	LD	B,H
 	LD	C,L
 	JP	XR1
 	END
