UK     ;uk/asm
 BTREAD1	EQU	4224H
 BTSEL	EQU	420FH
 BTSLOW	EQU	4215H
 BTBYTE	EQU	4295H
 BTLDMRK	EQU	428CH
 BTREAD	EQU	421CH
 BTMSG2	EQU	42DAH
 BTMSG3	EQU	42E5H
 BTMSG4	EQU	42F0H
 BTPRT	EQU	42BFH
 KIMBOOT	NOP
 	CP	17
 	CALL	1C9H
 	LD	BC,4DFFH
 	LD	DE,5
 	EXX
 	JR	BTLOAD		;go load and jump
 	LD	A,1		;BTSEL
 	LD	(37E1H),A	;select drive 0
 	RET
 	PUSH	BC
 	LD	B,12
 	DJNZ	$
 	POP	BC
 	RET
 	PUSH	BC		;BTREAD
 	CALL	BTREAD1		;try it once
 	POP	HL		;destroyed HL
 	RET	Z
 	LD	B,H
 	LD	C,L		;replace load address
 	CALL	BTSEL		;BTREAD1
 	LD	(37EEH),DE	;select track
 	LD	HL,37ECH	;point to controller
 	LD	(HL),1BH	;give seek command
 	CALL	BTSLOW
 BTSEEK	BIT	0,(HL)
 	JR	NZ,BTSEEK	;found it if Z
 	LD	(HL),88H	;issue read command
 	PUSH	DE		;save track/sector
 	LD	DE,37EFH	;transfer address
 	CALL	BTSLOW
 	JR	BTRD1
 BTRD2	RRCA
 	JR	NC,BTRD3
 BTRD1	LD	A,(HL)
 	BIT	1,A
 	JR	Z,BTRD2
 	LD	A,(DE)		;get a byte
 	LD	(BC),A		;put in buffer
 	INC	BC		;bump buffer
 	JR	BTRD1		;get next byte
 BTRD3	LD	A,(HL)		;get result
 	LD	(HL),0D0H	;force interrupt
 	POP	DE		;restore track/sector
 	AND	9CH		;check error status
 	RET
 BTLOAD	CALL	BTBYTE		;get one byte
 	CP	1
 	JR	Z,BTLOAD1
 	CP	2
 	JR	Z,BTENTRY
 	CP	20H
 	JR	NC,BTERRS
 	CALL	BTBYTE
 	LD	B,A
 BTLOAD3	CALL	BTBYTE
 	DJNZ	BTLOAD3
 	JR	BTLOAD
 BTLOAD1	CALL	BTBYTE		;get count byte
 	LD	B,A		;to B
 	CALL	BTLDMRK
 	DEC	B		;less 1
 	DEC	B
 BTLOAD2	CALL	BTBYTE
 	LD	(HL),A		;put in buffer
 	CP	(HL)		;test it
 	JR	NZ,BTBADM	;bad memory
 	INC	HL
 	DJNZ	BTLOAD2
 	JR	BTLOAD
 BTENTRY	CALL	BTBYTE
 	CALL	BTLDMRK
 	JP	(HL)		;go entry point
 	CALL	BTBYTE
 	LD	L,A
 	CALL	BTBYTE
 	LD	H,A
 	RET
 	EXX			;BTBYTE
 	INC	C		;bump position
 	JR	NZ,BTBYTE1	;already in buffer
 	PUSH	BC		;save count
 	CALL	BTREAD		;read the sector
 	POP	BC		;restore stack
 	JR	NZ,BTERRD	;read error
 	INC	E		;point to next sector
 	LD	A,E
 	SUB	0AH		;end of track?
 	JR	NZ,BTBYTE1
 	INC	D
 	LD	E,A
 BTBYTE1	LD	A,(BC)		;get a byte
 	EXX			;store here
 	RET			;have the byte
 BTERRS	LD	HL,BTMSG2
 	JR	BTERROR
 BTERRD	LD	HL,BTMSG3	;disk read error
 	JR	BTERROR		;print and halt
 BTBADM	LD	HL,BTMSG4
 BTERROR	CALL	BTPRT		;display message
 	CALL	40H		;wait for enter key
 	HALT			;re-boot
 	CALL	1C9H		;BTPRT
 	LD	A,23		;double size
 	JR	BTPRT1
 BTPRT2	LD	A,(HL)		;get a byte
 	INC	HL		;point to next
 BTPRT1	CALL	33H		;display the byte
 	CP	3		;terminator?
 	JR	NZ,BTPRT2	;go if not
 	RET			;else go back
 BTMSG1	DB	'SuperBOOT',3	;BTMSG1
 	DB	'Non-SYSTEM',3	;BTMSG2
 	DB	'Disk-ERROR',3	;BTMSG3
 	DB	'Memory-ERROR',3	;BTMSG4
 	DB	0,0,0
isplay the byte
 	CP	3		;terminator?
 	JR	NZ,BTPRT2	;go if not
 	RET			;else go back
 BTMSG1	DB	'SuperBOOT',3	;BTMSG1
 